package com.yeejoin.amos.boot.module.ugp.biz.controller;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.yeejoin.amos.boot.module.ugp.biz.fegin.MaasServiceFeignClient;
import com.yeejoin.amos.boot.module.ugp.biz.framework.BusinessIdentify;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.RequestMapping;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.Api;
import org.springframework.web.bind.annotation.RestController;
import com.yeejoin.amos.boot.biz.common.controller.BaseController;
import java.util.List;
import java.util.Map;

import com.yeejoin.amos.boot.module.ugp.biz.service.impl.AttachmentServiceImpl;
import org.typroject.tyboot.core.restful.utils.ResponseHelper;
import org.typroject.tyboot.core.restful.utils.ResponseModel;
import org.springframework.beans.factory.annotation.Autowired;
import javax.servlet.http.HttpServletRequest;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yeejoin.amos.boot.module.ugp.api.dto.AttachmentDto;
import org.typroject.tyboot.core.restful.doc.TycloudOperation;
import org.typroject.tyboot.core.foundation.enumeration.UserType;

/**
 * 附件表
 *
 * @author system_generator
 * @date 2022-09-22
 */
@RestController
@Api(tags = "附件表Api")
@RequestMapping(value = "/attachment")
public class AttachmentController extends BaseController {

    @Autowired
    AttachmentServiceImpl attachmentServiceImpl;

    /**
     * 新增附件表
     *
     * @return
     */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
	@PostMapping(value = "/save")
	@ApiOperation(httpMethod = "POST", value = "新增附件表", notes = "新增附件表")
	public ResponseModel<AttachmentDto> save(@RequestBody AttachmentDto model) {
	    model = attachmentServiceImpl.createWithModel(model);
	    return ResponseHelper.buildResponse(model);
	}

	/**
     * 根据sequenceNbr更新
     *
     * @param sequenceNbr 主键
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@PutMapping(value = "/{sequenceNbr}")
	@ApiOperation(httpMethod = "PUT", value = "根据sequenceNbr更新附件表", notes = "根据sequenceNbr更新附件表")
	public ResponseModel<AttachmentDto> updateBySequenceNbrAttachment(@RequestBody AttachmentDto model,@PathVariable(value = "sequenceNbr") Long sequenceNbr) {
	    model.setSequenceNbr(sequenceNbr);
	    return ResponseHelper.buildResponse(attachmentServiceImpl.updateWithModel(model));
	}

	/**
     * 根据sequenceNbr删除
     *
     * @param sequenceNbr 主键
     * @return
     */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
    @DeleteMapping(value = "/{sequenceNbr}")
    @ApiOperation(httpMethod = "DELETE", value = "根据sequenceNbr删除附件表", notes = "根据sequenceNbr删除附件表")
    public ResponseModel<Boolean> deleteBySequenceNbr(HttpServletRequest request, @PathVariable(value = "sequenceNbr") Long sequenceNbr){
        return ResponseHelper.buildResponse(attachmentServiceImpl.removeById(sequenceNbr));
    }

    /**
     * 根据sequenceNbr查询
     *
	 * @param sequenceNbr  主键
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/{sequenceNbr}")
	@ApiOperation(httpMethod = "GET",value = "根据sequenceNbr查询单个附件表",  notes = "根据sequenceNbr查询单个附件表")
	public ResponseModel<AttachmentDto> selectOne(@PathVariable Long sequenceNbr) {
	    return ResponseHelper.buildResponse(attachmentServiceImpl.queryBySeq(sequenceNbr));
	}

	/**
     * 列表分页查询
     *
     * @param current 当前页
     * @param current 每页大小
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/page")
	@ApiOperation(httpMethod = "GET",value = "附件表分页查询",  notes = "附件表分页查询")
	public ResponseModel<Page<AttachmentDto>> queryForPage(@RequestParam(value = "current") int current,@RequestParam
                    (value = "size") int size) {
	    Page<AttachmentDto> page = new Page<AttachmentDto>();
	    page.setCurrent(current);
	    page.setSize(size);
	    return ResponseHelper.buildResponse(attachmentServiceImpl.queryForAttachmentPage(page));
	}

	/**
	 * 列表全部数据查询
     *
	 * @return
	 */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@ApiOperation(httpMethod = "GET",value = "附件表列表全部数据查询",   notes = "附件表列表全部数据查询")
	@GetMapping(value = "/list")
	public ResponseModel<List<AttachmentDto>> selectForList() {
	    return ResponseHelper.buildResponse(attachmentServiceImpl.queryForAttachmentList());
	}

	/**
	 *  根据当前登录人获取单位
	 *
	 */
	@BusinessIdentify
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/unit")
	@ApiOperation(httpMethod = "Get",value="单位选择查询",notes= "单位选择查询")
	public ResponseModel<Map> selectUnit(){
		return ResponseHelper.buildResponse(attachmentServiceImpl.selectUnit());
	}

	@Autowired
	MaasServiceFeignClient maasServiceFeignClient;

	@Value("${maas.service.ocr.id}")
	String ocrServiceId;

	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/test")
	@ApiOperation(httpMethod = "Get",value="测试",notes= "测试")
	public ResponseModel test(@RequestParam String urlPath) {
		JSONObject param = new JSONObject();
		JSONArray urls = new JSONArray();
		JSONObject url = new JSONObject();
		url.put("url", urlPath);
		urls.add(url);
		param.put("data", urls);
		ResponseModel<Object> result = maasServiceFeignClient.execProcessApiByServiceId(param);
		String resultStr = JSONObject.parseObject(JSONObject.toJSONString(result.getResult())).getJSONObject("result1").getJSONArray("rows").getJSONObject(0).getString("ocrResult");
		return ResponseHelper.buildResponse(resultStr);
	}
}
